<?php
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Chatterblock Plugin 2.3 for Geeklog - The Ultimate Weblog                 |
// | By: Blaine Lang  - langmail@sympatico.ca                                  |
// | Nov 12/2002: First offical release Chatterblock as a plugin               |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things:                                                |
// | 1) Implements the necessary Geeklog Plugin API method                     |
// | 2) Includes phpblock_chatterblock() that would normally be in lib-custom  |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000,2001 by the following authors:                         |
// |                                                                           |
// | Authors: Tony Bibbs       - tony@tonybibbs.com                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: functions.inc,v 1.13 2002/08/12 10:47:56 dhaun Exp $

$langfile = $_CONF['path'] . 'plugins/chatterblock/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/chatterblock/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/chatterblock/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* This will put an option for the plugin in the command and control block in the admin/moderation.php
*/
function plugin_cclabel_chatterblock() 
{
    global $_CONF,$cb_lang;

    return array($cb_lang['prompt22'],$_CONF['site_admin_url'] . '/plugins/chatterblock/index.php',$_CONF['site_url'] . '/chatterblock/images/chatterblock.gif');
}

/**
* Returns the administrative menuitem option for this plugin
* Only one menu item can be returned.
*/
function plugin_getadminoption_chatterblock() 
{
    global $_CONF, $_TABLES,$cb_lang;
    if (SEC_hasRights('chatterblock.edit')) {
        return array($cb_lang['prompt22'], $_CONF['site_admin_url'] . '/plugins/chatterblock/index.php', DB_count($_TABLES['cb_chatterlog']));
    }
}

/**
* Returns the user menuitem option for this plugin
* Only one menu item can be returned.
*/
function plugin_getuseroption_chatterblock() 
{
    global $_CONF,$cb_lang,$cb_siteconfig;
	if ($cb_siteconfig['userprefs_access'] || SEC_hasRights('chatterblock.user')) {
        return array($cb_lang['prompt23'], $_CONF['site_url'] . '/chatterblock/cb_userprefs.php', 0);
    }
}

/**
* Shows the statistics for the plugin on stats.php. 
* Only the summary stat request is implemented for this plugin - when $showsitestats is 1 
*/
function plugin_showstats_chatterblock($showsitestats) {
    global $_CONF, $_TABLES, $LANG_PL00;

    $stat_templates = new Template($_CONF['path_layout'] . 'stats');
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));
        $retval='';
    if ($showsitestats == 1) {
        // This shows in the summary box
        $total_pages = DB_count($_TABLES['cb_chatterlog']);      // Fill this with count for summary
        $summary_label = $LANG_PL00['search_label'];            // Fill this with label displayed
        
        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>$summary_label</td>";
        $retval .= "<td align='right'>" . $total_pages . "&nbsp;&nbsp </td></tr></table>";
    } 
    return $retval;
}


/**
* Called by the plugin Editor to display the current plugin code version 
* This may be different then the version installed and registered currently.
* If newer then you may want to run the update
*/
function plugin_chkVersion_chatterblock() {
    global $CONF_CB; 
    return $CONF_CB['version'];
}


/**
* Called by the plugin Editor to run the SQL Update for a plugin update 
*/
function plugin_upgrade_chatterblock() {
    global $_TABLES,$CONF_CB;

    $curversion = DB_getItem($_TABLES['plugins'],'pi_version',"pi_name = 'chatterblock'");

    switch ($curversion) {

        case "3.0" :
            DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='3.01', pi_gl_version='1.3.11' WHERE pi_name='chatterblock'");
            break;
        default:
            DB_query("UPDATE {$_TABLES['plugins']} SET pi_version='3.1', pi_gl_version='1.4.1' WHERE pi_name='chatterblock'");
            break;
    }

    /* Check if update completed and return a message number to be shown */
    if (DB_getItem($_TABLES['plugins'],'pi_version',"pi_name = 'chatterblock'") == $CONF_CB['version']) {
        return 1;
    } else {
        return 5;
    }

}



/**
* Removes the datastructures for this plugin from the Geeklog database
* This may get called by the install routine to undue anything created during the install.
* Added check to see that plugin is first disabled. Will also remove the Block definition.
*/  
function plugin_uninstall_chatterblock()
{
    global $_TABLES, $LANG_PL00;

    $pi_name='chatterblock';
    $FEATURES = array ('chatterblock.edit', 'chatterblock.user');
    $TABLES = array ('cb_chatterlog','cb_userprefs');

	// Ok to proceed and delete plugin - Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the chatterblock plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'chatterblock'",1);
    // Drop chatterblock tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Admin Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_admin'");
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_admin'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
	
	// Remove all the associated features - access rights. The feature ID's were stored in the vars table during install.
	foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
		COM_errorLog("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }

    COM_errorLog("Removing Chatterblock - Block Definition ", 1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE phpblockfn = 'phpblock_chatterblock'",1);
        
    COM_errorLog('...success',1);
    return true;
}

// The main block function 
function phpblock_chatterblock()
{
    global $_CONF, $_USER, $_TABLES, $cb_lang;
    include($_CONF['path_html'] . "/chatterblock/cb_main.php");
    include_once($_CONF['path_html'] . "/chatterblock/include/cb_functions.php");
	
	$cb_config = cb_getConfig();
   
    // Display the chatterblock if this is a registered user or you have granted public access
    if ((SEC_hasRights('chatterblock.edit,chatterblock.user','OR')) || ($cb_config['public_access'])) {
	    if (cb_chk4newpost()) { // Check if this is a new post and not a duplicte post
            $display = cb_processForm($cb_config);
        } 
        cb_chk4deletereq(); // Check for a delete message request 
	
        $countsql = DB_query("SELECT COUNT(*) FROM " . $_TABLES['cb_chatterlog'] . " WHERE for_user is NULL AND archive='0'");
        list($chathits) = DB_fetchArray($countsql);
        $display .= '<font class="cb_chatcount">' . sprintf($cb_lang['prompt21'], $chathits) . '<br></font>';
        if ($cb_config['mode'] == "iframe") {
            $display .= '<center><iframe name="chatframe" scrolling="yes" marginwidth="0" marginheight="0" ';
            if ($cb_config['scroll_width'] == 0) {
                $display .= 'width="100%" ';
            } else {
                $display .= 'width="' .$cb_config['scroll_width']. '" ';
            }
            $display .= 'height="' . $cb_config['scroll_height'] . '" frameborder="1" src="' . $_CONF['site_url'] . '/chatterblock/cb_iframedisplay.php" ></iframe></center>';
        } elseif ($cb_config['mode'] == "smooth") {
	        $display .= '<div style=" ';
			if ($cb_config['scroll_width'] == 0) {
                $display .= 'width:100%; ';
            } else {
                $display .= 'width:' .$cb_config['scroll_width']. 'px; ';
            } 
			$display .= ' height:' .$cb_config['scroll_height']. 'px; border: 0px solid #999999; overflow: scroll;">';
		    $display .= cb_displayChatMessages($cb_config);
            $display .= '</div>';
		} else {
		    $display .= cb_displayChatMessages($cb_config);
		}	
		$display .= cb_postform($cb_config);
    } else {
        $display .= $cb_lang['prompt02'];
    } 

    return $display;
}

?>