<?php
// ------------------------------------------------------------------------- //
//                Geeklog - PHP Content Management System                    //
// ------------------------------------------------------------------------- //
// Main Function library for Chatterblock Plugin - Developed for Geeklog     //
// By: Blaine Lang  -  Nov 2002    blaine@portalparts.com                    //
//                                                                           //
// Nov 12/2002: First offical release v2.3 of Chatterblock                   //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //


// This function return the array used by chatterblock functions with site 
// defaults and user preferences
function cb_getConfig() {
    global $_TABLES,$_CONF,$_USER, $cb_lang;
    include($_CONF['path_html'] . "/chatterblock/cache/cb_config.php");
    if (empty($_USER['uid'])) {
        // Check for an existing user preference records - if not use site defaults
        $query1 = "select * from " .$_TABLES['cb_userprefs']. " where uid = '0'";
    } else {
       // Check if Site Preferences allow user defined settings  and if there is a record for this user
       if (!$cb_siteconfig['userprefs_access'] || (DB_count($_TABLES['cb_userprefs'],'uid',$_USER['uid']) == 0))  { 
            $query1 = "select * from " .$_TABLES['cb_userprefs']. " where uid = '0'";
        } else {
           $query1 = "select * from " .$_TABLES['cb_userprefs']. " where uid = '" .$_USER['uid']. "'";
        }   
    }
    $result1 = DB_query($query1);
    $cb_config= DB_fetchArray($result1);
    // Remaining site preferences are stored in chatterblock config file - read in from include at top of function
    $cb_config['scroll_width']      = $cb_siteconfig['scroll_width'];
    $cb_config['public_access']     = $cb_siteconfig['public_access'];
    $cb_config['track_ip']          = $cb_siteconfig['track_ip'];
    $cb_config['display_time']      = $cb_siteconfig['display_time'];
    $cb_config['anon_dispname']     = $cb_siteconfig['anon_dispname'];
    $cb_config['anon_entername']    = $cb_siteconfig['anon_entername'];
    $cb_config['userprefs_access']  = $cb_siteconfig['userprefs_access'];
    $cb_config['delete_last']       = $cb_siteconfig['delete_last'];
    $cb_config['log_access']        = $cb_siteconfig['log_access'];

    return $cb_config;
}

// This function formats the main input form but has to process a number of block defined options
function cb_postform($cb_config) {
    global $_TABLES, $_CONF, $_USER, $id, $REMOTE_ADDR,$cb_lang;

    $javascript = 
       '<script language="javascript">
       <!--
          var myParent=window.top;
          var initiallyClear = false;
       // -->
       </script>';
    $query1 = "select * from " .$_TABLES['cb_chatterlog']. " where time > '" .(time() - $cb_config['history'])
            . "' AND for_user is null AND archive='0' ";
    $result1 = DB_query($query1);
    $numchats = DB_numrows($result1);
    $result2 = DB_query("Select * from {$_TABLES['cb_chatterlog']} order by id desc limit 1");
    list($lastChatId,$lasttime) = DB_fetchARRAY($result2); 
    $short_date = strftime('%m/%d/%y&nbsp;%H:%M', $lasttime);
    $lastMsgPostDate = $short_date;
    $cb_delmsgPrompt='';
    // Check if block has delete last message enabled for user
    if ($cb_config['delete_last'] && $lastChatId !="") {
        if ((DB_getItem($_TABLES['cb_chatterlog'],'author_user',"id = $lastChatId") == $_USER['uid']) 
        OR (DB_getItem($_TABLES['cb_chatterlog'],'ip',"id = $lastChatId") == $REMOTE_ADDR)) {
            $cb_delmsgPrompt .= '<input type=checkbox name=cb_clrpost_' .$lastChatId. ' value=y><font class="cb_lastpost">' .$cb_lang['prompt05']. '</font><br>';
        }
    }
    $loc = $_CONF['site_url'] . "/index.php?";
    $cb_out  = $javascript . '<form name=chatterblock action="'.$loc.'" method="post">';
    $cb_out .= $cb_delmsgPrompt;
    // Check if anonymous users can enter a name
    if (empty($_USER['uid']) && $cb_config['anon_entername']) {
        $cb_out .= '<input type=text value="' .$cb_lang['prompt15']. '" name="cb_username" size="12" 
             maxlength="32"  onclick="myParent.chatterblock.cb_username.value=\'\';"><br>';
    }
    // Main enter text field for block       
    $cb_out .= '<input type=text value="' .$cb_lang['prompt16']. '" name="cb_message" size="25" 
        maxlength="255" onFocus="if(!initiallyClear){window.document.chatterblock.cb_message.value=\'\';initiallyClear =true;}">';
    $cb_out .= '<br><input type=submit name="cb_submit" value="' .$cb_lang['prompt11']. '">';
    $cb_out .= '&nbsp;&nbsp;&nbsp;<a href="javascript:void(0);" onClick="window.open(\''. $_CONF["site_url"]. '/chatterblock/help.html\',\'smiliehelp\',
        config=\'height=450,width=250,scrollbars=yes,top=50,left=150\');"><img src="' .$_CONF["site_url"]. '/chatterblock/images/cool.gif" border="0" title="'. $cb_lang['prompt14']. '"></a>';
    if ($cb_config['mode'] == "iframe") {
        $cb_out .= sprintf($cb_lang['prompt24'],($cb_config['refresh_rate']/1000));
    }

    $cb_out .= '</form>';
    $cb_out .= '<font class="cb_lastpost">';
    
       if ($cb_config['log_access'] || SEC_hasRights('chatterblock.edit')) {
        $cb_out .= '<b><font class="cb_logtitle"></font></b><a href="' . $_CONF["site_url"]. '/chatterblock/cb_chatLog.php?show=' .$cb_config['log_lines']. '">' .$cb_lang['prompt06']. '</a>';
    }
    if ($numchats > 0) {
        $cb_out .= sprintf($cb_lang['prompt09'],$lastMsgPostDate);
    } else {
        $cb_out .= '<br><br>';
    }
    $cb_out .= '</font>';
    return str_replace("\\", "&#92;", $cb_out);

}

// The main input form is processed by this function
function cb_processForm($cb_config)
{
    global $HTTP_POST_VARS, $_TABLES, $_CONF, $_USER, $id, $REMOTE_ADDR, $cb_lang;

    // check for a private message command - if so, extract user name, verify it, and post message if all checks out
    if (( !empty($_USER['uid']) && !empty($HTTP_POST_VARS['cb_message'])) || ($cb_config['public_access'] && !empty($HTTP_POST_VARS['cb_message']))) {

        if (($_USER['uid'] == 0 ) &&  ($HTTP_POST_VARS['cb_username'] != $cb_lang['prompt15'])) {
            $guestname = $HTTP_POST_VARS['cb_username'];
        } else {
            $guestname = "";
        }
        $message = addslashes(COM_checkHTML(COM_checkWords($HTTP_POST_VARS['cb_message'])));
        $sql2 = "insert into " .$_TABLES['cb_chatterlog']. "(msgtext, author_user, guestname, time, for_user, ip) 
            values ('" .$message. "','" .$_USER['uid']. "','" .$guestname. "'," .time(). ", NULL, '$REMOTE_ADDR')"; 
        DB_query($sql2); 

    } 
    
    return $cb_out;
}

// For the user defined number of hours of history, retrieve the chatterlog records and format for output
function cb_displayChatMessages($cb_config) {
     global $_TABLES, $_CONF, $_USER, $cb_lang;


     $starttablehead = '<table width="100%" border="0" cellpadding="0" cellspacing="0" ><tr><td width="100%" class="cb_text3">';
     $endtablehead = '</td></tr>';

     // Retrieve all selected history records 
     $query = "select * from " . $_TABLES['cb_chatterlog'] . " where time > '" . (time() - $cb_config['history'])
     . "' AND for_user is null AND archive='0' order by id desc";
      if ($cb_config['mode'] == "static") {
        $query .= " limit " . $cb_config['static_lines'];
     }
     $result = DB_query($query);
     $numchats = DB_numrows($result); 
     $lastMessageID = "";
      $onetwo = 1;
     if ($numchats == 0) {
         $lines = '<table width="100%" border="0" cellpadding="0" cellspacing="0" ><tr><td align="left" width="60%" class="cb_text1">';
         $lines .= $cb_lang['prompt10'];
         $lines .= '</td></tr></table>';
     }
     
     for ($i = 0; $i < $numchats; $i++) {
    
         $startMessageTable = '<table width="100%" border="0" cellpadding="0" cellspacing="0" ><tr><td align="left" width="50%" class="cb_text' . $onetwo . '">';
         $endMessageTable   = '</td></tr></table>';
         $line = $startMessageTable;
         $row = DB_fetchArray($result);
         $long_date = strftime('%B %d %Y @ %I:%M %p', $row['time']);
         $short_date = strftime('%m/%d/%y&nbsp;%H:%M', $row['time']);
         $submitter = cb_getnamebyuid($row['author_user']);
         $datePostedMsg = $cb_lang['prompt12'] . $long_date;
         $ipAddressMsg = $cb_lang['prompt13'] . $row['ip'];
         // Save the last Message ID - if current user is the author, we will allow an option to delete the last message
         if ($i == 0) {
             $lastMessageID = $row[id];
             $lastMsgPostDate = $short_date;
         } 
         if ($row['author_user'] == 0) {
             if ($row['guestname'] != "") {
                 $line .= '<font class="cb_guest">*' . $row['guestname'] . ': </font>';
             } else {
                 $line .= '<font class="cb_submitter">' . $cb_config['anon_dispname'] . ': </font>';
             } 
         } else {
             $line .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $row['author_user'] . '" target="_new">
                    <font class="cb_submitter">' .$submitter. '</font></a>:&nbsp;&nbsp;';
         } 
         $line .= '</td><td align="right" width="50%" class="cb_text' . $onetwo . '">';
         
         if ($cb_config['display_time']) {
             $line .= '<img src=' . $_CONF["site_url"] . '/chatterblock/images/info.gif BORDER="0" TITLE="' . $datePostedMsg . '">&nbsp;';
         }    
         if ($cb_config['track_ip']) {
            $line .= '<img src=' . $_CONF["site_url"] . '/chatterblock/images/ip.gif BORDER="0" TITLE="' . $ipAddressMsg . '">&nbsp;';
         } 

         $line .= '</td><tr><td colspan=2 class="cb_text' . $onetwo . '">';
        // Substitute the smillie BB style code for a 2 digit numeric code so the line length can be properly determined.
        // The smilies codes entered have different lengths but they really only take up space of three characters.
        $chatmessage = cb_useSmilieCode($row['msgtext']);
        $chatmessage = cb_replacesmile($chatmessage);
        $line .= $chatmessage . $endMessageTable;
        if (!$cb_config['newest_first']) {
             $lines = $line . $lines;
        } else {
            $lines .= $line;
        }
        if ($onetwo == 1) {
            $onetwo = 2;
        } else {
            $onetwo = 1;
        } 
    }
   
    // If site popup alert is enabled, check and see if there is a new message
    cb_chk4alert($cb_config,'public');

    return $lines;
    
}

// Called from main lib-custom function to check if there is a new post. Includes logic to check for duplicate post
function cb_chk4newpost() {
    global $HTTP_POST_VARS, $_CONF, $_TABLES,$cb_lang;

    $curPostMsg = $HTTP_POST_VARS['cb_message'];
    $query = DB_query("Select max(id) from {$_TABLES['cb_chatterlog']}");
    list($lastchatid) = DB_fetchARRAY($query);
    
    if ($lastchatid != "") {
        $query = DB_query("Select msgtext,for_user from {$_TABLES['cb_chatterlog']} where id = " .$lastchatid);
        list($lastmessage,$last_msguser) = DB_fetchARRAY($query);
        if (($lastmessage == $curPostMsg) || ($curPostMsg == $cb_lang['prompt16'])) {
            return false;   // Chatter message - Sames as last recorded messaage 
        }
    } else {
      return true;    // There is no chatterblock records - Could be first post
    }
    return true;  // Proceed and post Chatter Message
}

// Called from main lib-custom function to check if user has selected to delete last message they own
function cb_chk4deletereq() {
    global $HTTP_POST_VARS, $_USER, $_TABLES;
    foreach ($HTTP_POST_VARS as $key => $value) {
    // Test for request to clear last post or if user has Checked any private messages
        if (substr($key, 0, 11) == 'cb_clrpost_') {
            $id = addslashes(substr($key, 11, strlen($key)-11));
            $query = 'DELETE FROM '.$_TABLES['cb_chatterlog'] .' where id='.$id;
            DB_query($query);
        } elseif (substr($key, 0, 7) == 'cb_del_') {
            $id = addslashes(substr($key, 7, strlen($key)-7));
            $query = "DELETE FROM " .$_TABLES['cb_chatterlog']. " WHERE id='" .$id. "'";
            DB_query($query);
        }
    }
}

// Called from cb_postform to check for private messages. If so, they are formated and returned
function cb_dispPrivateMsgs() {
    global $_CONF, $_USER, $_TABLES, $cb_lang;

    $query = "select * from " .$_TABLES['cb_chatterlog']. " where for_user = '" .$_USER['uid']. "' AND checkoff is null"; 
    $result = DB_query($query); 
    for ($i = 0; $i < DB_numrows($result); $i++) { 
        $row = DB_fetchArray($result);
        $long_date = strftime('%B %d %Y @ %I:%M %p', $row['time']);
        $datePostedMsg = $cb_lang['prompt04'] .$long_date. "'";
        $cb_out .= '<br><img src=' .$_CONF["site_url"]. '/chatterblock/images/info.gif BORDER="0" TITLE="' .$datePostedMsg. '">';
        $cb_out .= '<input type=checkbox name=cb_del_' .$row['id']. ' value=y>' .  '<em>';
        if ($row['author_user'] == 0 ) {
            if ($row['guestname'] != "" ) {
                $cb_out .= '<b><font class="cb_link">' .$row['guestname']. '</font></b></a>' .$cb_lang['prompt17'];
            } else {
                $cb_out .= '<b><font class="cb_link">' .$cb_config['anon_dispname']. '</font></b></a>'.$cb_lang['prompt17'];
            }
        } else {
            $cb_out .= '<a href="' .$_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $row['author_user'] . '"' .
            $mouseoverMsg. '><b><font class="cb_link">' .cb_getnamebyuid($row['author_user']). '</font></b></a>'.$cb_lang['prompt17'];
        }
        $privMessage = cb_useSmilieCode($row['msgtext']);
        $privMessage = cb_replacesmile($privMessage);
        $cb_out .= $privMessage.  '</em><small> ' .$nice_date. '</small>';
    } 
    if (DB_numrows($result) != 0 || $cb_needs_hr) { 
        $cb_out .= "<hr>";
        cb_chk4alert($cb_config,'private');
    } 
    return $cb_out;
}

// This function is used only if block mode is set for iframe that allows for auto-refresh and popup's are allowed
// Site Admin's can customize the popup-alert style. The chatAlert() is included Javascript
// Site Admins need to customize the alert.html to read their site message to user
function cb_chk4alert($cb_config,$type) {
    global $_CONF, $_USER, $_TABLES;
    if ( !empty($_USER['uid']) && ($cb_config['mode'] == "iframe") && $cb_config['popup_allowed']) {
        $query = DB_query("Select id, author_user, for_user from {$_TABLES['cb_chatterlog']} order by id desc limit 1");
        list($lastPostedChatID,$userID,$private_user) = DB_fetchARRAY($query);
        // If this user does not have a user settings record yet - then check the default record
        if (DB_count($_TABLES['cb_userprefs'],'uid',$_USER['uid']) == 0) {
            $lastID = 0;
        } else {
            $lastID = $_USER['uid'];
        }
        // First check and see if there is a new message posted 
        if ($lastPostedChatID > DB_getItem($_TABLES['cb_userprefs'],'popup_allowed',"uid = $lastID" ))  { 
            // Now check if this message is Private, and for this user OR message is not Private, and user is signed in 
            if (( $type=='public' && $private_user == "" && $userID != $_USER['uid']) || ($type == 'private' && $private_user == $_USER['uid'])) {
                echo '<script language="javascript">
                      <!-- 
                         chatAlert(\'alert.html\');
                        //-->
                     </script>';
                // Update the last posted chat message ID - If user has enabled their own preferences then update their record
                    DB_query("UPDATE {$_TABLES['cb_userprefs']} SET popup_allowed='$lastPostedChatID' WHERE uid = $lastID"); 
            }        
        } 
   }
}  
   
?>